<?php
/******************************* PHP-P10 v2 *****************************
 * Copyright (C) 2011  Philipp Kreil (pk910)                            *
 *                                                                      *
 * This program is free software: you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation, either version 3 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      * 
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program. If not, see <http://www.gnu.org/licenses/>. *
 *                                                                      *
 ************************************************************************
 * 
 *  Uplink/EventHandler.interface.php
 *
 * This file contains the Uplink EventHandler interface.
 *
 */

interface EventHandler {
	
	public function event_newserver($server, $isBurst);
	public function event_squit($server);
	
	public function event_connect($user, $isBurst);
	public function event_nick($user, $newNick);
	public function event_usermode($user, $modes);
	public function event_quit($user, $reason);
	public function event_away($user, $away);
	
	public function event_join($user, $channel, $isBurst);
	public function event_part($user, $channel, $reason);
	public function event_kick($user, $target, $channel, $reason);
	public function event_chanmode($user, $channel, $modes);
	
	public function event_chanmessage($user, $channel, $message);
	public function event_channotice($user, $channel, $message);
	public function event_chanctcp($user, $channel, $command, $text);
	public function event_chanctcpreply($user, $target, $command, $text);
	public function event_privmessage($user, $target, $message);
	public function event_privnotice($user, $target, $message);
	public function event_privctcp($user, $target, $command, $text);
	public function event_privctcpreply($user, $target, $command, $text);
	
	
	public function event_preparse($from, $command, $arguments);
	public function event_unknown_cmd($from, $command, $arguments);
	
}

?>